<?php
/**
 * Copyright (c) 2016 Serhii Borodai <clarifying@gmail.com>.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 *
 */

namespace App\Action\Admin;


use App\Entity\Offers\OfferNew;
use App\Entity\Offers\Landing;
use App\Entity\Offers\AddNew;
use App\Entity\Offers\Template;
use App\Entity\Teasers\Offer;
use App\Entity\Teasers\Partner;
use App\Entity\Teasers\Add;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Slim\Flash\Messages;
use Zend\Diactoros\Response\HtmlResponse;
use Zend\Diactoros\Response\JsonResponse;
use Zend\Diactoros\Response\RedirectResponse;
use Zend\Hydrator\DelegatingHydrator;


/**
 * Class SystemAction
 * @package App\Action\Admin
 */
class SystemAction extends Common
{
    const ACTION_SYSTEM = 'system';
    
    
    /**
     * @param ServerRequestInterface $request
     * @param ResponseInterface $response
     * @param callable|null $next
     * @return HtmlResponse
     */
    function __invoke(ServerRequestInterface $request, ResponseInterface $response, callable $next = null)
    {
        
        if($request->getMethod() == 'POST') {
            
            try {
                switch ($request->getAttribute('action')) {
                    case self::ACTION_SYSTEM:    
                        $response = $this->createSystemRequest($request);
                        break;
                    default:                    
                }
            } catch(\Exception $e) {
                $data = [
                    'result' => false,
                    'msg' => $e->getMessage(),                    
                ];
                $response = new JsonResponse($data);
            }                        
            return $response;            
        }
        
    }
    
    private function createSystemRequest(ServerRequestInterface $request)
    {
        $data = $request->getParsedBody();
        
        // Перевести tpl в таблицу templates:
        if ($data['tplTemplatesTable']) {
            return $this->removeTplTemplatesTable($request);
        }
    }
    
    
    /* Системные операции */
    private function removeTplTemplatesTable(ServerRequestInterface $request)
    {
        /** @var \App\Model\Offers $landingsModel */
        $landingsModel = $this->container->get(\App\Model\Offers\Landings::class);
        $landings = $landingsModel->findAll();
        
        /** @var \App\Model\Offers $templatesModel */
        $templatesModel = $this->container->get(\App\Model\Offers\Templates::class);
        
        /** @var DelegatingHydrator $hydrator */
        $hydrator = $this->container->get(DelegatingHydrator::class);
        
        $land_ids = [];
        
        foreach($landings as $land) {
            
            if ($land->getTpl())
            {
                $land_tpl = $land->getTpl();
                
                if ($land_tpl != 'null' && $land_tpl != 'NULL')
                {
                    $land_ids[] = $land->getId();
                    
                    $land_tpl_val = json_decode($land_tpl, true);
                    
                    foreach($land_tpl_val as $id => $price) {
                        
                        $data = array(
                            'disabled' => false,
                            'landing_id' => $land->getId(),
                            'ad_data_id' => $id,
                            'price' => $price['price'],
                        );

                        $template = $hydrator->hydrate($data, new Template());
                        $templatesModel->createListItem($template);
                        
                    }
                }
                
            }
            
        }
        
        return new JsonResponse($land_ids);
        
    }
    
}